--Package.adb
with Ada.Text_IO;

package body Etudiants is
	package Txt renames Ada.Text_IO;
	Max_Etud: constant Integer := 20;

	--type Etudiant is record
		--Num:Integer;
		--Nom:String(1..20);
		--Classement:Integer;
		--Annee:Integer;	
	--end record;

	type Tab_Etud is array(Integer range<>) of Etudiant;
	Etud: Tab_Etud(1..Max_Etud):=((1,"Célia",9,3),(2,"Leandro",5,3),(3,"Baptiste",12,3),(4,"Yanis",7,2),(5,"Raphael",2,5),(6,"Paul",1,3),(7,"Matis",10,4),(8,"Jason",18,1),(9,"Vincent",11,2),(10,"Honorine",13,3),(11,"ML",3,3),(12,"Killian",4,3),(13,"Francois",6,4),(14,"Salome",8,2),(15,"Elsa",14,3),(16,"Justine",15,3),(17,"Dylan",16,5),(18,"Jerome",20,3),(19,"Gertrude",17,4),(20,"Nico",19,2));

	--Les étudiants sont numérotés de 1 à Max_Etud

	--Fonction renvoyant le classement de l'étudiant numéro Num
	function Classement_Etud(Num:Integer) return Integer is
		I:Integer:=1;
	begin
		if Num>Max_Etud then
			Txt.Put_Line("Attention, tu commences à chercher pour des numéros étudiants inexistants");
		else
			while Etud(I).Num/=Num loop
				I:=I+1;
			end loop;
		end if;
		return Etud(I).Classement;
	end Classement_Etud;

	--Fonction renvoyant l'année de l'étudiant numéro Num
	function Annee_Etud(Num:Integer) return Integer is
		I:Integer:=1;
	begin
		if Num>Max_Etud then
			Txt.Put_Line("Attention, tu commences à chercher pour des numéros étudiants inexistants");
		else
			while Etud(I).Num/=Num loop
				I:=I+1;
			end loop;
		return Etud(I).Annee;
		end if;
	end Annee_Etud;

	--Fonction renvoyant le nom de l'étudiant numéro Num
	function Nom_Etud(Num:Integer) return String is
		I:Integer:=1;
	begin
		if Num>Max_Etud then
			Txt.Put_Line("Attention, tu commences à chercher pour des numéros étudiants inexistants");
		else
			while Etud(I).Num/=Num loop
				I:=I+1;
			end loop;
		end if;
		return Etud(I).Nom;
	end Nom_Etud;

	--Procedure échangeant le numéro de l'étudiant Num1 et Num2
	procedure Echanger_Etud(Num1: Integer;Num2: Integer) is
		I:Integer:=1;
		Aux1:Integer:=1;
		Aux2:Integer:=1;
	begin
		if Num1>Max_Etud or Num2>Max_Etud then
			Txt.Put_Line("Attention, tu commences à chercher pour des numéros étudiants inexistants");
		else
			while Etud(I).Num/=Num1 loop
				I:=I+1;
			end loop;

			Aux1:=I;
			I:=1;
			while Etud(I).Num/=Num2 loop
				I:=I+1;
			end loop;

			Aux2:=I;
			I:=Etud(Aux1).Num;
			Etud(Aux1).Num:=Etud(Aux2).Num;
			Etud(Aux2).Num:=I;
		end if;
	end Echanger_Etud;

	--fonction renvoyant le numéro de l'étudiant avec le meilleur classement
	function Max_Classement(Debut:Integer) return Integer is
		I:Integer:=0;
		Min:Integer:=100;
		Ind_min:Integer:=1;
	begin
		if Debut>Max_Etud then
			Txt.Put_Line("Attention, tu commences à chercher pour des numéros étudiants inexistants");
		else
			while I<=Max_Etud loop
				if Etud(I).Num>Debut and then Etud(I).Classement<Min then
					Ind_min:=I;
					Min:=Etud(I).Classement;
				end if;
				I:=I+1;
			end loop;
		end if;
		return Ind_min;
	end Max_Classement;
end Etudiants;