--Package.ads
package Etudiants is

	--Nombre max d'étudiant
	Max_Etud: constant Integer := 20;

	type Etudiant is record:
		Num:Integer;
		Nom:String(1..20);
		Classement:Num;
		Annee:Integer;	
	end record;

	--Les étudiants sont numérotés de 1 à Max_Etud

	--Fonction renvoyant le classement de l'étudiant numéro Num
	function Classement_Etud(Num:Integer) return Integer;

	--Fonction renvoyant l'année de l'étudiant numéro Num
	function Annee_Etud(Num:Integer) return Integer;

	--Fonction renvoyant le nom de l'étudiant numéro Num
	function Nom_Etud(Num:Integer) return String;

	--Procedure échangeant les numéros des étudiants Num1 et Num2
	procedure Echanger_Etud(Num1: Integer,Num2: Integer);

	--fonction renvoyant le numéro de l'étudiant avec le meilleur classement, en commencant à regarder à partir de l'élève numéro Debut
	function Max_Classement(Debut:Integer) return Integer;

end Etudiants;